package  
{
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Mouse;
	import starling.display.Sprite;
	import starling.events.EnterFrameEvent;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	
	/**
	 * ...
	 * @author Alex
	 */
	public class GameMain extends Sprite 
	{
		
		public var background:SpaceBackground = new SpaceBackground();
		public var alienContainer:Sprite = new Sprite();
		public var bulletContainer:Sprite = new Sprite();
		public var ship:Spaceship;
		
		public var assets:Assets = new Assets();
		
		public function GameMain() 
		{
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event):void
		{
			// here we go, Starling Stage is ready
			Mouse.hide();
			
			ship = new Spaceship(bulletContainer);
			
			this.addChild(background);
			this.addChild(alienContainer);
			this.addChild(bulletContainer);
			this.addChild(ship);
			
			this.addEventListener(TouchEvent.TOUCH, mouseMove);
			this.addEventListener(EnterFrameEvent.ENTER_FRAME, gameLoop);
			trace("Go!");
		}
		
		private function gameLoop(e:Event):void
		{
			background.move( ship.speed *0.01 );
			
			
			// shoot if ready
			ship.shoot();
			
			// move Bullets & check for out of map
			for (var k:int = 0; k < bulletContainer.numChildren; k++)
			{
				//move
				var b:Bullet = bulletContainer.getChildAt(k) as Bullet;
				b.move();
				// out of map?
				if (b.y < -50)
				{
					bulletContainer.removeChildAt(k, true);
				}
			}
			
			// Spawn Aliens
			if ( Math.random() < 0.03 )
			{
				spawnAlien();
			}
			// move Aliens & check for out of map
			for(var i:int = 0; i < alienContainer.numChildren; i++)
			{
				//move
				var a:Alien = alienContainer.getChildAt(i) as Alien;
				//a.y += ship.speed * 0.03 + a.speed;
				
				alienContainer.getChildAt(i).y += ship.speed * 0.03 + a.speed;
				
				//out of map?
				if (a.y < -100)
				{
					alienContainer.removeChildAt(i, true);
				}
				else if (a.y > this.stage.stageHeight + 100)
				{
					alienContainer.removeChildAt(i, true);
				}
				
				for (var j:int = 0; j < bulletContainer.numChildren; j++)
				{
					var b:Bullet = bulletContainer.getChildAt(j) as Bullet;
					
					if ( a.getBounds(a.parent).intersects(b.getBounds(b.parent)) && a )
					{
						a.kill();
						b.remove();
					}
					
				}
				
			}
			
			
			
		}
		
		private function mouseMove(e:TouchEvent):void
		{
			var touch:Touch = e.getTouch(stage);
			if(touch)
			{
				if(touch.phase == TouchPhase.BEGAN)
				{
					ship.isShooting = true;
				}
				else if(touch.phase == TouchPhase.ENDED)
				{
					ship.isShooting = false;
				}
				else if(touch.phase == TouchPhase.MOVED || touch.phase == TouchPhase.HOVER )
				{
					ship.x = touch.globalX;
					ship.y = touch.globalY;
					
					ship.speed = (this.stage.stageHeight * 0.75 - ship.y);
				}
			}
		}
		
		private function spawnAlien():void
		{
			var alien:Alien = new Alien();
			alien.x = (Math.random()* this.stage.width)
			alienContainer.addChild(alien);
		}
		
		
		
	}

}